#include <fcntl.h>
#include <linux/soundcard.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <unistd.h>


int 
main()
{
	int fd, fragsize, arg;
	audio_buf_info buf;

	fd = open( "/dev/dsp", O_WRONLY );
	arg = 0x000f0005;

	if ( ioctl( fd, SNDCTL_DSP_SETFRAGMENT, &arg ) == -1 ) {
		perror( "ioctl(SNDCTL_DSP_SETFRAGMENT)" );
		close( fd );
		return 1;
	}

	if ( ioctl( fd, SNDCTL_DSP_GETBLKSIZE, &fragsize ) == -1 ) {
		perror( "ioctl(SNDCTL_DSP_GETBLKSIZE)" );
		close( fd );
		return 1;
	}

	printf( "fragsize = %d\n", fragsize );

	if ( ioctl( fd, SNDCTL_DSP_GETOSPACE, &buf ) == -1 ) {
		perror( "ioctl(SNDCTL_DSP_GETISPACE)" );
		close( fd );
		return 1;
	}

	printf( "buf.fragments  = %d\n", buf.fragments );
	printf( "buf.fragstotal = %d\n", buf.fragstotal );
	printf( "buf.fragsize   = %d\n", buf.fragsize );
	printf( "buf.bytes      = %d\n", buf.bytes );

	close( fd );
	return 0;
}

/* End of fragment_test.c */
