#include <fcntl.h>
#include <linux/soundcard.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <unistd.h>


int 
main( int argc, char** argv )
{
	int fd;
	int channel, level, mask;
	int i;

	/* soundcard.h Ƥͥ̾ */
	const char* sound_device_names[] = SOUND_DEVICE_NAMES;

	if ( argc < 3 || argc > 5 ) {
		printf( "usage : mixer_set vol <channel name> <left volume>"
			" <right volume>\n" );
		printf( "    or  mixer_set vol <channel name> <volume>\n" );
		printf( "    or  mixer_set rec <channel name>\n" );
		return 1;
	}


	/* Ƥͥο롼 */
	for ( i = 0; i < SOUND_MIXER_NRDEVICES; i ++ ) {
		if ( strcmp( argv[2], sound_device_names[i] ) == 0 ) {
			channel = i;
			break;
		}
	}
    
	/* ꤷǥХ̾Ƥʤ */
	if ( i == SOUND_MIXER_NRDEVICES ) {
		printf( "specified channel is not defined\n" );
		return 1;
	}

	/* write() ǽ񤭹櫓ʤΤǤɤ */
	if ( ( fd = open( "/dev/mixer", O_RDONLY ) ) == -1 ) {
		perror( "open" );
		return 1;
	}

	/* ܥ塼 */
	if ( strcmp( argv[1], "vol" ) == 0 ) {
		/* ܥ塼Υ󥳡 */
		if ( argc == 4 ) {
			level =   atoi( argv[3] );
		}
		else if ( argc == 5 ) {
			level = ( atoi( argv[4] ) << 8 ) | atoi( argv[3] );
		}

		/* ǥХ˥ܥ塼ꤹ */
		if ( ioctl( fd, MIXER_WRITE( channel ), &level ) == -1 ) {
			perror( "ioctl(MIXER_WRITE())" );
			close( fd );
			return 1;
		}
	}
	else if ( strcmp( argv[1], "rec" ) == 0 ) {
		/* Ͽ */
		mask = ( 1 << channel );

		if ( ioctl( fd, SOUND_MIXER_WRITE_RECSRC, &mask ) == -1 ) {
			perror( "ioctl(SOUND_MIXER_WRITE_RECSRC)" );
			close( fd );
			return 1;
		}
	}

	close( fd );
	return 0;
}

/* End of mixer_set.c */
